不灭的焱

革命尚未成功,同志仍须努力下载JDK17

作者:Albert.Wen  添加时间:2022-05-23 00:42:18  修改时间:2023-01-31 16:00:56  分类:Java框架/系统  编辑

一、首先在Spring Boot项目中,手动添加异常方法进行测试

@Transactional(rollbackFor=Exception.class) //表示此方法有异常时触发Spring事务
@Override
public CommonResult<User> saveUser(User user) {
    int insert = baseMapper.insert(user);
    try {
        // 添加异常,并进行捕获
        int a = 10/0;
    } catch (Exception e) {
        logger.info("打印异常信息:"+e);
        return CommonResult.commentFailure("服务器异常,事务回滚");
    }
	
    if (insert > 0) {
        return CommonResult.commentSuccess(user);
    } else {
        return CommonResult.commentFailure("添加失败");
    }
}

1、一个添加信息的实现类方法上,此处我们加了Spring的事务。

2、问题:一个方法报异常(int a = 10/0)进行了异常捕获,另一个方法不会回滚(insert添加方法)

这是什么情况呢,相当于Spring事务策略失效了。

try-catch捕获了异常后,这种业务方法也就等于脱离了spring事务的管理,因为没有任何异常会从业务方法中抛出,全被捕获并“吞掉”,导致spring异常抛出触发事务回滚策略失效。

通俗的来说:默认spring事务只在发生未被捕获的runtimeexcetpionerror时才回滚。

二、处理方案一

spring aop 异常捕获进而回滚。在catch中最后加上throw new runtimeexcetpion(),这样程序异常时才能被aop捕获进而回滚,缺点是无法return异常信息提示,前端用户交互效果不佳。

@Transactional(rollbackFor=Exception.class)  //表示此方法有异常时触发Spring事务
@Override
public CommonResult<User> saveUser(User user) {
    int insert = baseMapper.insert(user);
    try {
        // 添加异常,并进行捕获
        int a = 10/0;
    } catch (Exception e) {
        logger.info("异常信息:"+e);
        // 方案一:spring aop 异常捕获
        throw new RuntimeException();
    }
    
	if (insert > 0) {
        return CommonResult.commentSuccess(user);
    } else {
        return CommonResult.commentFailure("添加失败");
    }
}

三、处理方案二

就是让一个方法报异常,另一个方法回滚,这样才能真正的触发Spring事务回滚策略。

catch语句中增加:

TransactionAspectSupport.currentTransactionStatus().setRollbackOnly(); //手动回滚,这样上层就无需去处理异常了

完整代码:

@Transactional(rollbackFor=Exception.class) //表示此方法有异常时触发Spring事务
@Override
 public CommonResult<User> saveUser(User user) {
     int insert = baseMapper.insert(user);
     try {
         // 添加异常,并进行捕获
         int a = 10/0;
     } catch (Exception e) {
         logger.info("异常信息:"+e);
         // 方案二:手动回滚
         TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
         return CommonResult.commentFailure("服务器异常,事务回滚");
     }
	 
     if (insert > 0) {
         return CommonResult.commentSuccess(user);
     } else {
         return CommonResult.commentFailure("添加失败");
     }
 }

四、如过需要手动进行手动回滚的业务方法比较多,我们可以写一个公共的工具类

SpringRollBackUtil.java

public class SpringRollBackUtil {
    /**
     * 事务回滚机制
     */
    public static void rollBack() {
        try {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

只需调用方法即可

// 方案三:公共工具类 手动回滚
SpringRollBackUtil.rollBack();

 

 

摘自:https://blog.csdn.net/qq_41107231/article/details/106698940